<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>Classwork</title>

    <script>

    /*
      Задание:
      1. При помощи методов изложеных ниже, переформатировать ITEA_COURSES в массив который содержит длину строк каждого из элементов.
      2. Самостоятельно изучить метод Array.sort. Отфильтровать массив ITEA_COURSES по алфавиту.
          + Бонусный бал. Вывести на страничку списком
      3. Реализация функции поиска по массиву ITEA_COURSES.
          + Бонусный бал. Вывести на страничку инпут и кнопку по которой будет срабатывать поиск.
    */

    const ITEA_COURSES = ["Курс HTML & CSS", "JavaScript базовый курс", "JavaScript продвинутый курс", "JavaScript Professional", "Angular 2.4 (базовый)", "Angular 2.4 (продвинутый)", "React.js", "React Native", "Node.js", "Vue.js"];

    const ArrayLength = (element, key) => {
     return element.length;
     }
   
    let MappedArray = ITEA_COURSES.map(ArrayLength);
    console.log(MappedArray);

    let sort_array = ITEA_COURSES.sort();
    console.log(sort_array);
    
    const html = `
        <ul id ="ul">По алфавиту</ul>
        <input type="text" id="text"></input>
        <button id="search">Поиск курсов по буквам</button>
        <div id="result"></div>
      `;



    window.onload = () => {
      let list_div = document.createElement("div");
      document.body.appendChild(list_div);
      
      list_div.innerHTML = html;

      let ul = document.getElementById("ul");
      let text = document.getElementById("text");
      let btn = document.getElementById("search");
      let result_search = document.getElementById("result");

      sort_array.forEach( (element) =>{
        let li = document.createElement("li");
        ul.appendChild(li);
        li.innerHTML = element;
        })

        btn.addEventListener("click", () =>{
          let value = text.value;
          
          const Search = (value) =>{
            let massiv = ITEA_COURSES.filter( item => item.indexOf(value) != -1)
            return massiv;
        }
          result_search.innerHTML = Search(value);
      })


        const html2 = `
          <select id ="stars"></select>
          <select id ="durations"></select>
          <div id="film">
            <ul id ="ul2"></ul>
          </div>
        `;

        let select_div = document.createElement("div");
          document.body.appendChild(select_div);
          select_div.innerHTML = html2;
        let select_starts = document.getElementById("stars");
        let ul_movie = document.getElementById("ul2");
        let duration = document.getElementById("durations");
        
        let option;
        for (var i=0; i<stars.length; i++){
          option = new Option (stars[i], i);
          select_starts.appendChild(option);
        }

        let option2;
        for (var i=0; i<movies.length; i++){
          option2 = new Option (movies[i].duration, i);
          duration.appendChild(option2);
        }

         const MovieFind = () =>{
          ul_movie.innerHTML = "";
          let movieIsNeed = movies.filter ( (item) => {
             for (let i =0; i < item.starring.length; i++){
              if (item.starring[i] == select_starts[select_starts.value].text && item.duration == duration[duration.value].text){
                return item
              }
             }
          
          })
          movieIsNeed.forEach( (element) =>{
            let li_movie = document.createElement("li");
            ul_movie.appendChild(li_movie);
            li_movie.innerHTML = element.name;
          })
          }

          select_starts.addEventListener("change",MovieFind);
          duration.addEventListener("change",MovieFind);
       }
      
    /*
      Задание 2:
      Написать фильтр массива по:
      Актеру, продолжительности

      Бонус:
        Сделать графическую оболочку для программы:
        - Селект со списком актеров
        - Селект или инпут с продолжительностью
        - Результат в виде списка фильмов
    */

      var stars = ['Elijah Wood', 'Ian McKellen', 'Orlando Bloom','Ewan McGregor',' Liam Neeson', 'Natalie Portman', 'Ewan McGregor', 'Billy Bob Thornton', 'Martin Freeman']
      var movies = [
          {
            name: "Lord of the Rigs",
            duration: 240,
            starring: [ 'Elijah Wood', 'Ian McKellen', 'Orlando Bloom']
          },
          {
            name: "Star Wars: Episode I - The Phantom Menace",
            duration: 136,
            starring: [ 'Ewan McGregor',' Liam Neeson', 'Natalie Portman']
          },
          {
            name: "Fargo",
            duration: 100,
            starring: [ 'Ewan McGregor', 'Billy Bob Thornton', 'Martin Freeman']
          },
          {
          name: "V for Vendetta",
          duration: 150,
          starring: [ 'Hugo Weaving', 'Natalie Portman', 'Rupert Graves']
        }
        ];



    </script>
</head>
<body>

</body>
</html>
